/*-------------------------------------------------------------------------*/
/* GNU Prolog                                                              */
/*                                                                         */
/* Part  : Prolog buit-in predicates                                       */
/* File  : t_c.c                                                           */
/* Descr.: test - C part                                                   */
/* Author: Daniel Diaz                                                     */
/*                                                                         */
/* Copyright (C) 1999 Daniel Diaz                                          */
/*                                                                         */
/* GNU Prolog is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the   */
/* Free Software Foundation; either version 2, or any later version.       */
/*                                                                         */
/* GNU Prolog is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of              */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* General Public License for more details.                                */
/*                                                                         */
/* You should have received a copy of the GNU General Public License along */
/* with this program; if not, write to the Free Software Foundation, Inc.  */
/* 59 Temple Place - Suite 330, Boston, MA 02111, USA.                     */
/*-------------------------------------------------------------------------*/
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "engine_pl.h"
#include "bips_pl.h"


/*---------------------------------*/
/* Constants                       */
/*---------------------------------*/

/*---------------------------------*/
/* Type Definitions                */
/*---------------------------------*/

/*---------------------------------*/
/* Global Variables                */
/*---------------------------------*/

/*---------------------------------*/
/* Function Prototypes             */
/*---------------------------------*/

/*-------------------------------------------------------------------------*/
/*                                                                         */
/*                                                                         */
/*-------------------------------------------------------------------------*/
Bool Test(WamWord w)

{
#if 0
 Check_For_Un_Callable(w);
 return TRUE;

#elif 0
 Emit_Syntax_Error(Rd_String_Check(w),1,1,"syn err from C");
 return FALSE;

#elif 0
 WamWord *arg;
 int i,func,arity;

 arg=Rd_Callable_Check(w,&func,&arity);
 printf("functor=%s arity=%d\n",atom_tbl[func].name,arity);

 for(i=0;i<arity;i++)
   {
    printf("  arg %d=",i); Write_Simple(arg[i]);
    printf("\n");
   }
 return TRUE;
#elif 0

 WamWord arg[16];

 arg[0]=Mk_Integer(12);
 arg[1]=Mk_Float(12.56);
 arg[2]=Mk_String("toto");
 return Un_Compound_Check(atom_char['f'],3,arg,w);

#elif 0

 WamWord arg[16];
 WamWord r;

 arg[0]=Mk_Integer(12);
 arg[1]=Mk_Float(12.56);
 arg[2]=Mk_String("toto");
 r=Mk_Compound(atom_char['.'],2,arg);
 return Unify(w,r);

#elif 0

 WamWord arg[256];
 int     n,i;

 n=Rd_Proper_List(w,arg);
 for(i=0;i<n;i++)
     Write_Simple(arg[i]), putchar('\n');
 return TRUE;

#elif 0

 WamWord arg[16];

 arg[0]=Mk_Integer(12);
 arg[1]=Mk_Float(12.56);
 arg[2]=Mk_String("toto");

 return Un_Proper_List_Check(3,arg,w);

#elif 1

 WamWord arg[16];
 WamWord r;

 arg[0]=Mk_Integer(12);
 arg[1]=Mk_Float(12.56);
 arg[2]=Mk_String("toto");
 r=Mk_Proper_List(3,arg);

 return Unify(w,r);

#endif
}
